package com.supwisdom.dlpay.system.service.impl;

import com.supwisdom.dlpay.framework.dao.ShopDao;
import com.supwisdom.dlpay.framework.dao.ShopaccDao;
import com.supwisdom.dlpay.framework.domain.TShop;
import com.supwisdom.dlpay.framework.domain.TShopacc;
import com.supwisdom.dlpay.framework.util.StringUtil;
import com.supwisdom.dlpay.framework.util.TradeDict;
import com.supwisdom.dlpay.system.bean.ZTreeNode;
import com.supwisdom.dlpay.system.service.ShopDataService;
import com.supwisdom.dlpay.util.WebCheckException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class ShopDataServiceImpl implements ShopDataService {
  @Autowired
  private ShopDao shopDao;
  @Autowired
  private ShopaccDao shopaccDao;

  @Override
  public List<ZTreeNode> getAllShopNodes() {
    List<ZTreeNode> result = new ArrayList<>(0);
    List<TShop> shoplist = shopDao.findAll();
    if (!StringUtil.isEmpty(shoplist)) {
      for (TShop shop : shoplist) {
        if (null == shop || !TradeDict.STATUS_NORMAL.equals(shop.getStatus())) continue; //跳过注销商户
        ZTreeNode node = new ZTreeNode();
        node.setId(shop.getShopid().toString());
        node.setName(shop.getShopname());
        node.setpId(shop.getFshopid() == null ? "" : shop.getFshopid().toString());
        node.setChecked(false);
        node.setOpen(true);
        node.setShoptype(shop.getShoptype());
        result.add(node);
      }
    }
    return result;
  }

  @Override
  public TShop getShopByShopid(Integer shopid) {
    if (null != shopid) {
      return shopDao.getTShopByShopid(shopid);
    }
    return null;
  }

  @Override
  public boolean deleteShop(TShop shop) throws WebCheckException{
    if(null!=shop){
      List<TShop> childShops = shopDao.getChildShopsByShopid(shop.getShopid());
      if(!StringUtil.isEmpty(childShops))
        throw new WebCheckException("请先删除下级商户");
      shop.setStatus(TradeDict.STATUS_CLOSED);
      shopDao.save(shop);
      if(!StringUtil.isEmpty(shop.getShopaccno())){
        TShopacc shopacc=shopaccDao.getByShopaccno(shop.getShopaccno());
        if(null==shopacc) throw new WebCheckException("数据异常！对应的商户账户不存在！");
        shopacc.setStatus(TradeDict.STATUS_CLOSED);
        shopaccDao.save(shopacc);
      }
      return true;
    }
    return false;
  }


}
